<?php

namespace Ups_pickup;

/**
 * Class which returns the class map definition
 * @package Ups_pickup
 */
class Ups_pickupClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'UPSSecurity' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupUPSSecurity',
            'UsernameToken' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupUsernameToken',
            'ServiceAccessToken' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupServiceAccessToken',
            'Errors' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupErrors',
            'ErrorDetailType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupErrorDetailType',
            'ElementLevelInformationType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupElementLevelInformationType',
            'ElementIdentifierType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupElementIdentifierType',
            'CodeType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupCodeType',
            'AdditionalInfoType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupAdditionalInfoType',
            'AdditionalCodeDescType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupAdditionalCodeDescType',
            'LocationType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupLocationType',
            'ClientInformationType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupClientInformationType',
            'Property' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupProperty',
            'RequestType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupRequestType',
            'TransactionReferenceType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupTransactionReferenceType',
            'ResponseType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupResponseType',
            'CodeDescriptionType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupCodeDescriptionType',
            'DetailType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupDetailType',
            'PickupGetPoliticalDivision1ListRequest' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupGetPoliticalDivision1ListRequest',
            'PickupCreationRequest' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupCreationRequest',
            'PickupGetServiceCenterFacilitiesRequest' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupGetServiceCenterFacilitiesRequest',
            'PickupRateRequest' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupRateRequest',
            'PickupCancelRequest' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupCancelRequest',
            'PickupPendingStatusRequest' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupPendingStatusRequest',
            'PickupGetPoliticalDivision1ListResponse' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupGetPoliticalDivision1ListResponse',
            'PickupCreationResponse' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupCreationResponse',
            'PickupRateResponse' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupRateResponse',
            'PickupCancelResponse' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupCancelResponse',
            'PickupPendingStatusResponse' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupPendingStatusResponse',
            'PickupGetServiceCenterFacilitiesResponse' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupGetServiceCenterFacilitiesResponse',
            'ServiceCenterLocationsType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupServiceCenterLocationsType',
            'DropOffFacilitiesType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupDropOffFacilitiesType',
            'PickupFacilitiesType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupFacilitiesType',
            'FacilityTimeType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupFacilityTimeType',
            'DayOfWeekType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupDayOfWeekType',
            'PickupPieceType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupPieceType',
            'PickupPieceServiceType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupPieceServiceType',
            'TodayType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupTodayType',
            'FutureServiceDateType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupFutureServiceDateType',
            'PickupDateInfoType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupDateInfoType',
            'WeightType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupWeightType',
            'ShipperAccountType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupShipperAccountType',
            'ShipperType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupShipperType',
            'TaxInformationType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupTaxInformationType',
            'AccountType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupAccountType',
            'ChargeCardType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupChargeCardType',
            'ChargeCardAddressType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupChargeCardAddressType',
            'OriginAddressType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupOriginAddressType',
            'DestinationAddressType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupDestinationAddressType',
            'AddressType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupAddressType',
            'PickupAddressType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPickupAddressType',
            'StreetAddressArtifactType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupStreetAddressArtifactType',
            'PhoneType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPhoneType',
            'CSRType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupCSRType',
            'StatusCodeDescriptionType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupStatusCodeDescriptionType',
            'RateResultType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupRateResultType',
            'ChargeDetailType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupChargeDetailType',
            'PendingStatusType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPendingStatusType',
            'TrackingDataType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupTrackingDataType',
            'TrackingDataWithReferenceNumberType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupTrackingDataWithReferenceNumberType',
            'FreightOptionsType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupFreightOptionsType',
            'ServiceType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupServiceType',
            'ShipmentServiceOptionsType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupShipmentServiceOptionsType',
            'ShipmentDetailType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupShipmentDetailType',
            'PalletInformationType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupPalletInformationType',
            'DimensionsType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupDimensionsType',
            'UnitOfMeasurementType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupUnitOfMeasurementType',
            'OriginSearchCriteriaType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupOriginSearchCriteriaType',
            'LocalizedInstructionType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupLocalizedInstructionType',
            'DistanceType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupDistanceType',
            'DisclaimerType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupDisclaimerType',
            'TaxChargeType' => '\\Ups_pickup\\upspickupStruct\\Ups_pickupTaxChargeType',
        );
    }
}
