<?php

namespace Ups_pickup\upspickupStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ChargeCardType upspickupStruct
 * @package Ups_pickup
 * @subpackage Structs
 */
class Ups_pickupChargeCardType extends AbstractStructBase
{
    /**
     * The CardHolderName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $CardHolderName;
    /**
     * The CardType
     * @var string
     */
    public $CardType;
    /**
     * The CardNumber
     * @var string
     */
    public $CardNumber;
    /**
     * The ExpirationDate
     * @var string
     */
    public $ExpirationDate;
    /**
     * The SecurityCode
     * @var string
     */
    public $SecurityCode;
    /**
     * The CardAddress
     * @var \Ups_pickup\upspickupStruct\Ups_pickupChargeCardAddressType
     */
    public $CardAddress;
    /**
     * Constructor method for ChargeCardType
     * @uses Ups_pickupChargeCardType::setCardHolderName()
     * @uses Ups_pickupChargeCardType::setCardType()
     * @uses Ups_pickupChargeCardType::setCardNumber()
     * @uses Ups_pickupChargeCardType::setExpirationDate()
     * @uses Ups_pickupChargeCardType::setSecurityCode()
     * @uses Ups_pickupChargeCardType::setCardAddress()
     * @param string $cardHolderName
     * @param string $cardType
     * @param string $cardNumber
     * @param string $expirationDate
     * @param string $securityCode
     * @param \Ups_pickup\upspickupStruct\Ups_pickupChargeCardAddressType $cardAddress
     */
    public function __construct($cardHolderName = null, $cardType = null, $cardNumber = null, $expirationDate = null, $securityCode = null, \Ups_pickup\upspickupStruct\Ups_pickupChargeCardAddressType $cardAddress = null)
    {
        $this
            ->setCardHolderName($cardHolderName)
            ->setCardType($cardType)
            ->setCardNumber($cardNumber)
            ->setExpirationDate($expirationDate)
            ->setSecurityCode($securityCode)
            ->setCardAddress($cardAddress);
    }
    /**
     * Get CardHolderName value
     * @return string|null
     */
    public function getCardHolderName()
    {
        return $this->CardHolderName;
    }
    /**
     * Set CardHolderName value
     * @param string $cardHolderName
     * @return \Ups_pickup\upspickupStruct\Ups_pickupChargeCardType
     */
    public function setCardHolderName($cardHolderName = null)
    {
        // validation for constraint: string
        if (!is_null($cardHolderName) && !is_string($cardHolderName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cardHolderName, true), gettype($cardHolderName)), __LINE__);
        }
        $this->CardHolderName = $cardHolderName;
        return $this;
    }
    /**
     * Get CardType value
     * @return string|null
     */
    public function getCardType()
    {
        return $this->CardType;
    }
    /**
     * Set CardType value
     * @param string $cardType
     * @return \Ups_pickup\upspickupStruct\Ups_pickupChargeCardType
     */
    public function setCardType($cardType = null)
    {
        // validation for constraint: string
        if (!is_null($cardType) && !is_string($cardType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cardType, true), gettype($cardType)), __LINE__);
        }
        $this->CardType = $cardType;
        return $this;
    }
    /**
     * Get CardNumber value
     * @return string|null
     */
    public function getCardNumber()
    {
        return $this->CardNumber;
    }
    /**
     * Set CardNumber value
     * @param string $cardNumber
     * @return \Ups_pickup\upspickupStruct\Ups_pickupChargeCardType
     */
    public function setCardNumber($cardNumber = null)
    {
        // validation for constraint: string
        if (!is_null($cardNumber) && !is_string($cardNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cardNumber, true), gettype($cardNumber)), __LINE__);
        }
        $this->CardNumber = $cardNumber;
        return $this;
    }
    /**
     * Get ExpirationDate value
     * @return string|null
     */
    public function getExpirationDate()
    {
        return $this->ExpirationDate;
    }
    /**
     * Set ExpirationDate value
     * @param string $expirationDate
     * @return \Ups_pickup\upspickupStruct\Ups_pickupChargeCardType
     */
    public function setExpirationDate($expirationDate = null)
    {
        // validation for constraint: string
        if (!is_null($expirationDate) && !is_string($expirationDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($expirationDate, true), gettype($expirationDate)), __LINE__);
        }
        $this->ExpirationDate = $expirationDate;
        return $this;
    }
    /**
     * Get SecurityCode value
     * @return string|null
     */
    public function getSecurityCode()
    {
        return $this->SecurityCode;
    }
    /**
     * Set SecurityCode value
     * @param string $securityCode
     * @return \Ups_pickup\upspickupStruct\Ups_pickupChargeCardType
     */
    public function setSecurityCode($securityCode = null)
    {
        // validation for constraint: string
        if (!is_null($securityCode) && !is_string($securityCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($securityCode, true), gettype($securityCode)), __LINE__);
        }
        $this->SecurityCode = $securityCode;
        return $this;
    }
    /**
     * Get CardAddress value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupChargeCardAddressType|null
     */
    public function getCardAddress()
    {
        return $this->CardAddress;
    }
    /**
     * Set CardAddress value
     * @param \Ups_pickup\upspickupStruct\Ups_pickupChargeCardAddressType $cardAddress
     * @return \Ups_pickup\upspickupStruct\Ups_pickupChargeCardType
     */
    public function setCardAddress(\Ups_pickup\upspickupStruct\Ups_pickupChargeCardAddressType $cardAddress = null)
    {
        $this->CardAddress = $cardAddress;
        return $this;
    }
}
