<?php

namespace Ups_pickup\upspickupStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DayOfWeekType upspickupStruct
 * @package Ups_pickup
 * @subpackage Structs
 */
class Ups_pickupDayOfWeekType extends AbstractStructBase
{
    /**
     * The Day
     * @var string
     */
    public $Day;
    /**
     * The EarliestDropOfforPickup
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $EarliestDropOfforPickup;
    /**
     * The LatestDropOfforPickup
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $LatestDropOfforPickup;
    /**
     * The OpenHours
     * @var string
     */
    public $OpenHours;
    /**
     * The CloseHours
     * @var string
     */
    public $CloseHours;
    /**
     * The PrepTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $PrepTime;
    /**
     * The LastDrop
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $LastDrop;
    /**
     * Constructor method for DayOfWeekType
     * @uses Ups_pickupDayOfWeekType::setDay()
     * @uses Ups_pickupDayOfWeekType::setEarliestDropOfforPickup()
     * @uses Ups_pickupDayOfWeekType::setLatestDropOfforPickup()
     * @uses Ups_pickupDayOfWeekType::setOpenHours()
     * @uses Ups_pickupDayOfWeekType::setCloseHours()
     * @uses Ups_pickupDayOfWeekType::setPrepTime()
     * @uses Ups_pickupDayOfWeekType::setLastDrop()
     * @param string $day
     * @param string $earliestDropOfforPickup
     * @param string $latestDropOfforPickup
     * @param string $openHours
     * @param string $closeHours
     * @param string $prepTime
     * @param string $lastDrop
     */
    public function __construct($day = null, $earliestDropOfforPickup = null, $latestDropOfforPickup = null, $openHours = null, $closeHours = null, $prepTime = null, $lastDrop = null)
    {
        $this
            ->setDay($day)
            ->setEarliestDropOfforPickup($earliestDropOfforPickup)
            ->setLatestDropOfforPickup($latestDropOfforPickup)
            ->setOpenHours($openHours)
            ->setCloseHours($closeHours)
            ->setPrepTime($prepTime)
            ->setLastDrop($lastDrop);
    }
    /**
     * Get Day value
     * @return string|null
     */
    public function getDay()
    {
        return $this->Day;
    }
    /**
     * Set Day value
     * @param string $day
     * @return \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType
     */
    public function setDay($day = null)
    {
        // validation for constraint: string
        if (!is_null($day) && !is_string($day)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($day, true), gettype($day)), __LINE__);
        }
        $this->Day = $day;
        return $this;
    }
    /**
     * Get EarliestDropOfforPickup value
     * @return string|null
     */
    public function getEarliestDropOfforPickup()
    {
        return $this->EarliestDropOfforPickup;
    }
    /**
     * Set EarliestDropOfforPickup value
     * @param string $earliestDropOfforPickup
     * @return \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType
     */
    public function setEarliestDropOfforPickup($earliestDropOfforPickup = null)
    {
        // validation for constraint: string
        if (!is_null($earliestDropOfforPickup) && !is_string($earliestDropOfforPickup)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($earliestDropOfforPickup, true), gettype($earliestDropOfforPickup)), __LINE__);
        }
        $this->EarliestDropOfforPickup = $earliestDropOfforPickup;
        return $this;
    }
    /**
     * Get LatestDropOfforPickup value
     * @return string|null
     */
    public function getLatestDropOfforPickup()
    {
        return $this->LatestDropOfforPickup;
    }
    /**
     * Set LatestDropOfforPickup value
     * @param string $latestDropOfforPickup
     * @return \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType
     */
    public function setLatestDropOfforPickup($latestDropOfforPickup = null)
    {
        // validation for constraint: string
        if (!is_null($latestDropOfforPickup) && !is_string($latestDropOfforPickup)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($latestDropOfforPickup, true), gettype($latestDropOfforPickup)), __LINE__);
        }
        $this->LatestDropOfforPickup = $latestDropOfforPickup;
        return $this;
    }
    /**
     * Get OpenHours value
     * @return string|null
     */
    public function getOpenHours()
    {
        return $this->OpenHours;
    }
    /**
     * Set OpenHours value
     * @param string $openHours
     * @return \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType
     */
    public function setOpenHours($openHours = null)
    {
        // validation for constraint: string
        if (!is_null($openHours) && !is_string($openHours)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($openHours, true), gettype($openHours)), __LINE__);
        }
        $this->OpenHours = $openHours;
        return $this;
    }
    /**
     * Get CloseHours value
     * @return string|null
     */
    public function getCloseHours()
    {
        return $this->CloseHours;
    }
    /**
     * Set CloseHours value
     * @param string $closeHours
     * @return \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType
     */
    public function setCloseHours($closeHours = null)
    {
        // validation for constraint: string
        if (!is_null($closeHours) && !is_string($closeHours)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($closeHours, true), gettype($closeHours)), __LINE__);
        }
        $this->CloseHours = $closeHours;
        return $this;
    }
    /**
     * Get PrepTime value
     * @return string|null
     */
    public function getPrepTime()
    {
        return $this->PrepTime;
    }
    /**
     * Set PrepTime value
     * @param string $prepTime
     * @return \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType
     */
    public function setPrepTime($prepTime = null)
    {
        // validation for constraint: string
        if (!is_null($prepTime) && !is_string($prepTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($prepTime, true), gettype($prepTime)), __LINE__);
        }
        $this->PrepTime = $prepTime;
        return $this;
    }
    /**
     * Get LastDrop value
     * @return string|null
     */
    public function getLastDrop()
    {
        return $this->LastDrop;
    }
    /**
     * Set LastDrop value
     * @param string $lastDrop
     * @return \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType
     */
    public function setLastDrop($lastDrop = null)
    {
        // validation for constraint: string
        if (!is_null($lastDrop) && !is_string($lastDrop)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastDrop, true), gettype($lastDrop)), __LINE__);
        }
        $this->LastDrop = $lastDrop;
        return $this;
    }
}
