<?php

namespace Ups_pickup\upspickupStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Errors upspickupStruct
 * @package Ups_pickup
 * @subpackage Structs
 */
class Ups_pickupErrors extends AbstractStructBase
{
    /**
     * The ErrorDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \Ups_pickup\upspickupStruct\Ups_pickupErrorDetailType[]
     */
    public $ErrorDetail;
    /**
     * Constructor method for Errors
     * @uses Ups_pickupErrors::setErrorDetail()
     * @param \Ups_pickup\upspickupStruct\Ups_pickupErrorDetailType[] $errorDetail
     */
    public function __construct(array $errorDetail = array())
    {
        $this
            ->setErrorDetail($errorDetail);
    }
    /**
     * Get ErrorDetail value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupErrorDetailType[]|null
     */
    public function getErrorDetail()
    {
        return $this->ErrorDetail;
    }
    /**
     * This method is responsible for validating the values passed to the setErrorDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErrorDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateErrorDetailForArrayConstraintsFromSetErrorDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $errorsErrorDetailItem) {
            // validation for constraint: itemType
            if (!$errorsErrorDetailItem instanceof \Ups_pickup\upspickupStruct\Ups_pickupErrorDetailType) {
                $invalidValues[] = is_object($errorsErrorDetailItem) ? get_class($errorsErrorDetailItem) : sprintf('%s(%s)', gettype($errorsErrorDetailItem), var_export($errorsErrorDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ErrorDetail property can only contain items of type \Ups_pickup\upspickupStruct\Ups_pickupErrorDetailType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ErrorDetail value
     * @throws \InvalidArgumentException
     * @param \Ups_pickup\upspickupStruct\Ups_pickupErrorDetailType[] $errorDetail
     * @return \Ups_pickup\upspickupStruct\Ups_pickupErrors
     */
    public function setErrorDetail(array $errorDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($errorDetailArrayErrorMessage = self::validateErrorDetailForArrayConstraintsFromSetErrorDetail($errorDetail))) {
            throw new \InvalidArgumentException($errorDetailArrayErrorMessage, __LINE__);
        }
        $this->ErrorDetail = $errorDetail;
        return $this;
    }
    /**
     * Add item to ErrorDetail value
     * @throws \InvalidArgumentException
     * @param \Ups_pickup\upspickupStruct\Ups_pickupErrorDetailType $item
     * @return \Ups_pickup\upspickupStruct\Ups_pickupErrors
     */
    public function addToErrorDetail(\Ups_pickup\upspickupStruct\Ups_pickupErrorDetailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups_pickup\upspickupStruct\Ups_pickupErrorDetailType) {
            throw new \InvalidArgumentException(sprintf('The ErrorDetail property can only contain items of type \Ups_pickup\upspickupStruct\Ups_pickupErrorDetailType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ErrorDetail[] = $item;
        return $this;
    }
}
