<?php

namespace Ups_pickup\upspickupStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FacilityTimeType upspickupStruct
 * @package Ups_pickup
 * @subpackage Structs
 */
class Ups_pickupFacilityTimeType extends AbstractStructBase
{
    /**
     * The DayOfWeek
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType[]
     */
    public $DayOfWeek;
    /**
     * Constructor method for FacilityTimeType
     * @uses Ups_pickupFacilityTimeType::setDayOfWeek()
     * @param \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType[] $dayOfWeek
     */
    public function __construct(array $dayOfWeek = array())
    {
        $this
            ->setDayOfWeek($dayOfWeek);
    }
    /**
     * Get DayOfWeek value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType[]|null
     */
    public function getDayOfWeek()
    {
        return $this->DayOfWeek;
    }
    /**
     * This method is responsible for validating the values passed to the setDayOfWeek method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDayOfWeek method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDayOfWeekForArrayConstraintsFromSetDayOfWeek(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $facilityTimeTypeDayOfWeekItem) {
            // validation for constraint: itemType
            if (!$facilityTimeTypeDayOfWeekItem instanceof \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType) {
                $invalidValues[] = is_object($facilityTimeTypeDayOfWeekItem) ? get_class($facilityTimeTypeDayOfWeekItem) : sprintf('%s(%s)', gettype($facilityTimeTypeDayOfWeekItem), var_export($facilityTimeTypeDayOfWeekItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DayOfWeek property can only contain items of type \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DayOfWeek value
     * @throws \InvalidArgumentException
     * @param \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType[] $dayOfWeek
     * @return \Ups_pickup\upspickupStruct\Ups_pickupFacilityTimeType
     */
    public function setDayOfWeek(array $dayOfWeek = array())
    {
        // validation for constraint: array
        if ('' !== ($dayOfWeekArrayErrorMessage = self::validateDayOfWeekForArrayConstraintsFromSetDayOfWeek($dayOfWeek))) {
            throw new \InvalidArgumentException($dayOfWeekArrayErrorMessage, __LINE__);
        }
        $this->DayOfWeek = $dayOfWeek;
        return $this;
    }
    /**
     * Add item to DayOfWeek value
     * @throws \InvalidArgumentException
     * @param \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType $item
     * @return \Ups_pickup\upspickupStruct\Ups_pickupFacilityTimeType
     */
    public function addToDayOfWeek(\Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType) {
            throw new \InvalidArgumentException(sprintf('The DayOfWeek property can only contain items of type \Ups_pickup\upspickupStruct\Ups_pickupDayOfWeekType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DayOfWeek[] = $item;
        return $this;
    }
}
