<?php

namespace Ups_pickup\upspickupStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FutureServiceDateType upspickupStruct
 * @package Ups_pickup
 * @subpackage Structs
 */
class Ups_pickupFutureServiceDateType extends AbstractStructBase
{
    /**
     * The ServiceDate
     * @var string
     */
    public $ServiceDate;
    /**
     * The CallByTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $CallByTime;
    /**
     * The EarliestCloseTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $EarliestCloseTime;
    /**
     * The LeadTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $LeadTime;
    /**
     * The GWNIndicator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $GWNIndicator;
    /**
     * Constructor method for FutureServiceDateType
     * @uses Ups_pickupFutureServiceDateType::setServiceDate()
     * @uses Ups_pickupFutureServiceDateType::setCallByTime()
     * @uses Ups_pickupFutureServiceDateType::setEarliestCloseTime()
     * @uses Ups_pickupFutureServiceDateType::setLeadTime()
     * @uses Ups_pickupFutureServiceDateType::setGWNIndicator()
     * @param string $serviceDate
     * @param string $callByTime
     * @param string $earliestCloseTime
     * @param string $leadTime
     * @param string $gWNIndicator
     */
    public function __construct($serviceDate = null, $callByTime = null, $earliestCloseTime = null, $leadTime = null, $gWNIndicator = null)
    {
        $this
            ->setServiceDate($serviceDate)
            ->setCallByTime($callByTime)
            ->setEarliestCloseTime($earliestCloseTime)
            ->setLeadTime($leadTime)
            ->setGWNIndicator($gWNIndicator);
    }
    /**
     * Get ServiceDate value
     * @return string|null
     */
    public function getServiceDate()
    {
        return $this->ServiceDate;
    }
    /**
     * Set ServiceDate value
     * @param string $serviceDate
     * @return \Ups_pickup\upspickupStruct\Ups_pickupFutureServiceDateType
     */
    public function setServiceDate($serviceDate = null)
    {
        // validation for constraint: string
        if (!is_null($serviceDate) && !is_string($serviceDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serviceDate, true), gettype($serviceDate)), __LINE__);
        }
        $this->ServiceDate = $serviceDate;
        return $this;
    }
    /**
     * Get CallByTime value
     * @return string|null
     */
    public function getCallByTime()
    {
        return $this->CallByTime;
    }
    /**
     * Set CallByTime value
     * @param string $callByTime
     * @return \Ups_pickup\upspickupStruct\Ups_pickupFutureServiceDateType
     */
    public function setCallByTime($callByTime = null)
    {
        // validation for constraint: string
        if (!is_null($callByTime) && !is_string($callByTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callByTime, true), gettype($callByTime)), __LINE__);
        }
        $this->CallByTime = $callByTime;
        return $this;
    }
    /**
     * Get EarliestCloseTime value
     * @return string|null
     */
    public function getEarliestCloseTime()
    {
        return $this->EarliestCloseTime;
    }
    /**
     * Set EarliestCloseTime value
     * @param string $earliestCloseTime
     * @return \Ups_pickup\upspickupStruct\Ups_pickupFutureServiceDateType
     */
    public function setEarliestCloseTime($earliestCloseTime = null)
    {
        // validation for constraint: string
        if (!is_null($earliestCloseTime) && !is_string($earliestCloseTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($earliestCloseTime, true), gettype($earliestCloseTime)), __LINE__);
        }
        $this->EarliestCloseTime = $earliestCloseTime;
        return $this;
    }
    /**
     * Get LeadTime value
     * @return string|null
     */
    public function getLeadTime()
    {
        return $this->LeadTime;
    }
    /**
     * Set LeadTime value
     * @param string $leadTime
     * @return \Ups_pickup\upspickupStruct\Ups_pickupFutureServiceDateType
     */
    public function setLeadTime($leadTime = null)
    {
        // validation for constraint: string
        if (!is_null($leadTime) && !is_string($leadTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($leadTime, true), gettype($leadTime)), __LINE__);
        }
        $this->LeadTime = $leadTime;
        return $this;
    }
    /**
     * Get GWNIndicator value
     * @return string|null
     */
    public function getGWNIndicator()
    {
        return $this->GWNIndicator;
    }
    /**
     * Set GWNIndicator value
     * @param string $gWNIndicator
     * @return \Ups_pickup\upspickupStruct\Ups_pickupFutureServiceDateType
     */
    public function setGWNIndicator($gWNIndicator = null)
    {
        // validation for constraint: string
        if (!is_null($gWNIndicator) && !is_string($gWNIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($gWNIndicator, true), gettype($gWNIndicator)), __LINE__);
        }
        $this->GWNIndicator = $gWNIndicator;
        return $this;
    }
}
