<?php

namespace Ups_pickup\upspickupStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PendingStatusType upspickupStruct
 * @package Ups_pickup
 * @subpackage Structs
 */
class Ups_pickupPendingStatusType extends AbstractStructBase
{
    /**
     * The PickupType
     * @var string
     */
    public $PickupType;
    /**
     * The ServiceDate
     * @var string
     */
    public $ServiceDate;
    /**
     * The PRN
     * @var string
     */
    public $PRN;
    /**
     * The GWNStatusCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $GWNStatusCode;
    /**
     * The OnCallStatusCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $OnCallStatusCode;
    /**
     * The PickupStatusMessage
     * @var string
     */
    public $PickupStatusMessage;
    /**
     * The BillingCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $BillingCode;
    /**
     * The ContactName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ContactName;
    /**
     * The ReferenceNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ReferenceNumber;
    /**
     * Constructor method for PendingStatusType
     * @uses Ups_pickupPendingStatusType::setPickupType()
     * @uses Ups_pickupPendingStatusType::setServiceDate()
     * @uses Ups_pickupPendingStatusType::setPRN()
     * @uses Ups_pickupPendingStatusType::setGWNStatusCode()
     * @uses Ups_pickupPendingStatusType::setOnCallStatusCode()
     * @uses Ups_pickupPendingStatusType::setPickupStatusMessage()
     * @uses Ups_pickupPendingStatusType::setBillingCode()
     * @uses Ups_pickupPendingStatusType::setContactName()
     * @uses Ups_pickupPendingStatusType::setReferenceNumber()
     * @param string $pickupType
     * @param string $serviceDate
     * @param string $pRN
     * @param string $gWNStatusCode
     * @param string $onCallStatusCode
     * @param string $pickupStatusMessage
     * @param string $billingCode
     * @param string $contactName
     * @param string $referenceNumber
     */
    public function __construct($pickupType = null, $serviceDate = null, $pRN = null, $gWNStatusCode = null, $onCallStatusCode = null, $pickupStatusMessage = null, $billingCode = null, $contactName = null, $referenceNumber = null)
    {
        $this
            ->setPickupType($pickupType)
            ->setServiceDate($serviceDate)
            ->setPRN($pRN)
            ->setGWNStatusCode($gWNStatusCode)
            ->setOnCallStatusCode($onCallStatusCode)
            ->setPickupStatusMessage($pickupStatusMessage)
            ->setBillingCode($billingCode)
            ->setContactName($contactName)
            ->setReferenceNumber($referenceNumber);
    }
    /**
     * Get PickupType value
     * @return string|null
     */
    public function getPickupType()
    {
        return $this->PickupType;
    }
    /**
     * Set PickupType value
     * @param string $pickupType
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType
     */
    public function setPickupType($pickupType = null)
    {
        // validation for constraint: string
        if (!is_null($pickupType) && !is_string($pickupType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pickupType, true), gettype($pickupType)), __LINE__);
        }
        $this->PickupType = $pickupType;
        return $this;
    }
    /**
     * Get ServiceDate value
     * @return string|null
     */
    public function getServiceDate()
    {
        return $this->ServiceDate;
    }
    /**
     * Set ServiceDate value
     * @param string $serviceDate
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType
     */
    public function setServiceDate($serviceDate = null)
    {
        // validation for constraint: string
        if (!is_null($serviceDate) && !is_string($serviceDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serviceDate, true), gettype($serviceDate)), __LINE__);
        }
        $this->ServiceDate = $serviceDate;
        return $this;
    }
    /**
     * Get PRN value
     * @return string|null
     */
    public function getPRN()
    {
        return $this->PRN;
    }
    /**
     * Set PRN value
     * @param string $pRN
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType
     */
    public function setPRN($pRN = null)
    {
        // validation for constraint: string
        if (!is_null($pRN) && !is_string($pRN)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pRN, true), gettype($pRN)), __LINE__);
        }
        $this->PRN = $pRN;
        return $this;
    }
    /**
     * Get GWNStatusCode value
     * @return string|null
     */
    public function getGWNStatusCode()
    {
        return $this->GWNStatusCode;
    }
    /**
     * Set GWNStatusCode value
     * @param string $gWNStatusCode
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType
     */
    public function setGWNStatusCode($gWNStatusCode = null)
    {
        // validation for constraint: string
        if (!is_null($gWNStatusCode) && !is_string($gWNStatusCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($gWNStatusCode, true), gettype($gWNStatusCode)), __LINE__);
        }
        $this->GWNStatusCode = $gWNStatusCode;
        return $this;
    }
    /**
     * Get OnCallStatusCode value
     * @return string|null
     */
    public function getOnCallStatusCode()
    {
        return $this->OnCallStatusCode;
    }
    /**
     * Set OnCallStatusCode value
     * @param string $onCallStatusCode
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType
     */
    public function setOnCallStatusCode($onCallStatusCode = null)
    {
        // validation for constraint: string
        if (!is_null($onCallStatusCode) && !is_string($onCallStatusCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($onCallStatusCode, true), gettype($onCallStatusCode)), __LINE__);
        }
        $this->OnCallStatusCode = $onCallStatusCode;
        return $this;
    }
    /**
     * Get PickupStatusMessage value
     * @return string|null
     */
    public function getPickupStatusMessage()
    {
        return $this->PickupStatusMessage;
    }
    /**
     * Set PickupStatusMessage value
     * @param string $pickupStatusMessage
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType
     */
    public function setPickupStatusMessage($pickupStatusMessage = null)
    {
        // validation for constraint: string
        if (!is_null($pickupStatusMessage) && !is_string($pickupStatusMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pickupStatusMessage, true), gettype($pickupStatusMessage)), __LINE__);
        }
        $this->PickupStatusMessage = $pickupStatusMessage;
        return $this;
    }
    /**
     * Get BillingCode value
     * @return string|null
     */
    public function getBillingCode()
    {
        return $this->BillingCode;
    }
    /**
     * Set BillingCode value
     * @param string $billingCode
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType
     */
    public function setBillingCode($billingCode = null)
    {
        // validation for constraint: string
        if (!is_null($billingCode) && !is_string($billingCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($billingCode, true), gettype($billingCode)), __LINE__);
        }
        $this->BillingCode = $billingCode;
        return $this;
    }
    /**
     * Get ContactName value
     * @return string|null
     */
    public function getContactName()
    {
        return $this->ContactName;
    }
    /**
     * Set ContactName value
     * @param string $contactName
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType
     */
    public function setContactName($contactName = null)
    {
        // validation for constraint: string
        if (!is_null($contactName) && !is_string($contactName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactName, true), gettype($contactName)), __LINE__);
        }
        $this->ContactName = $contactName;
        return $this;
    }
    /**
     * Get ReferenceNumber value
     * @return string|null
     */
    public function getReferenceNumber()
    {
        return $this->ReferenceNumber;
    }
    /**
     * Set ReferenceNumber value
     * @param string $referenceNumber
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType
     */
    public function setReferenceNumber($referenceNumber = null)
    {
        // validation for constraint: string
        if (!is_null($referenceNumber) && !is_string($referenceNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($referenceNumber, true), gettype($referenceNumber)), __LINE__);
        }
        $this->ReferenceNumber = $referenceNumber;
        return $this;
    }
}
