<?php

namespace Ups_pickup\upspickupStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PickupCancelResponse upspickupStruct
 * @package Ups_pickup
 * @subpackage Structs
 */
class Ups_pickupPickupCancelResponse extends AbstractStructBase
{
    /**
     * The Response
     * Meta information extracted from the WSDL
     * - ref: common:Response
     * @var \Ups_pickup\upspickupStruct\Ups_pickupResponseType
     */
    public $Response;
    /**
     * The PickupType
     * @var string
     */
    public $PickupType;
    /**
     * The GWNStatus
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_pickup\upspickupStruct\Ups_pickupStatusCodeDescriptionType
     */
    public $GWNStatus;
    /**
     * Constructor method for PickupCancelResponse
     * @uses Ups_pickupPickupCancelResponse::setResponse()
     * @uses Ups_pickupPickupCancelResponse::setPickupType()
     * @uses Ups_pickupPickupCancelResponse::setGWNStatus()
     * @param \Ups_pickup\upspickupStruct\Ups_pickupResponseType $response
     * @param string $pickupType
     * @param \Ups_pickup\upspickupStruct\Ups_pickupStatusCodeDescriptionType $gWNStatus
     */
    public function __construct(\Ups_pickup\upspickupStruct\Ups_pickupResponseType $response = null, $pickupType = null, \Ups_pickup\upspickupStruct\Ups_pickupStatusCodeDescriptionType $gWNStatus = null)
    {
        $this
            ->setResponse($response)
            ->setPickupType($pickupType)
            ->setGWNStatus($gWNStatus);
    }
    /**
     * Get Response value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupResponseType|null
     */
    public function getResponse()
    {
        return $this->Response;
    }
    /**
     * Set Response value
     * @param \Ups_pickup\upspickupStruct\Ups_pickupResponseType $response
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupCancelResponse
     */
    public function setResponse(\Ups_pickup\upspickupStruct\Ups_pickupResponseType $response = null)
    {
        $this->Response = $response;
        return $this;
    }
    /**
     * Get PickupType value
     * @return string|null
     */
    public function getPickupType()
    {
        return $this->PickupType;
    }
    /**
     * Set PickupType value
     * @param string $pickupType
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupCancelResponse
     */
    public function setPickupType($pickupType = null)
    {
        // validation for constraint: string
        if (!is_null($pickupType) && !is_string($pickupType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pickupType, true), gettype($pickupType)), __LINE__);
        }
        $this->PickupType = $pickupType;
        return $this;
    }
    /**
     * Get GWNStatus value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupStatusCodeDescriptionType|null
     */
    public function getGWNStatus()
    {
        return $this->GWNStatus;
    }
    /**
     * Set GWNStatus value
     * @param \Ups_pickup\upspickupStruct\Ups_pickupStatusCodeDescriptionType $gWNStatus
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupCancelResponse
     */
    public function setGWNStatus(\Ups_pickup\upspickupStruct\Ups_pickupStatusCodeDescriptionType $gWNStatus = null)
    {
        $this->GWNStatus = $gWNStatus;
        return $this;
    }
}
