<?php

namespace Ups_pickup\upspickupStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PickupCreationResponse upspickupStruct
 * @package Ups_pickup
 * @subpackage Structs
 */
class Ups_pickupPickupCreationResponse extends AbstractStructBase
{
    /**
     * The Response
     * Meta information extracted from the WSDL
     * - ref: common:Response
     * @var \Ups_pickup\upspickupStruct\Ups_pickupResponseType
     */
    public $Response;
    /**
     * The PRN
     * @var string
     */
    public $PRN;
    /**
     * The WeekendServiceTerritoryIndicator
     * Meta information extracted from the WSDL
     * - default: N
     * - minOccurs: 0
     * @var string
     */
    public $WeekendServiceTerritoryIndicator;
    /**
     * The RateStatus
     * @var \Ups_pickup\upspickupStruct\Ups_pickupStatusCodeDescriptionType
     */
    public $RateStatus;
    /**
     * The RateResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_pickup\upspickupStruct\Ups_pickupRateResultType
     */
    public $RateResult;
    /**
     * Constructor method for PickupCreationResponse
     * @uses Ups_pickupPickupCreationResponse::setResponse()
     * @uses Ups_pickupPickupCreationResponse::setPRN()
     * @uses Ups_pickupPickupCreationResponse::setWeekendServiceTerritoryIndicator()
     * @uses Ups_pickupPickupCreationResponse::setRateStatus()
     * @uses Ups_pickupPickupCreationResponse::setRateResult()
     * @param \Ups_pickup\upspickupStruct\Ups_pickupResponseType $response
     * @param string $pRN
     * @param string $weekendServiceTerritoryIndicator
     * @param \Ups_pickup\upspickupStruct\Ups_pickupStatusCodeDescriptionType $rateStatus
     * @param \Ups_pickup\upspickupStruct\Ups_pickupRateResultType $rateResult
     */
    public function __construct(\Ups_pickup\upspickupStruct\Ups_pickupResponseType $response = null, $pRN = null, $weekendServiceTerritoryIndicator = 'N', \Ups_pickup\upspickupStruct\Ups_pickupStatusCodeDescriptionType $rateStatus = null, \Ups_pickup\upspickupStruct\Ups_pickupRateResultType $rateResult = null)
    {
        $this
            ->setResponse($response)
            ->setPRN($pRN)
            ->setWeekendServiceTerritoryIndicator($weekendServiceTerritoryIndicator)
            ->setRateStatus($rateStatus)
            ->setRateResult($rateResult);
    }
    /**
     * Get Response value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupResponseType|null
     */
    public function getResponse()
    {
        return $this->Response;
    }
    /**
     * Set Response value
     * @param \Ups_pickup\upspickupStruct\Ups_pickupResponseType $response
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupCreationResponse
     */
    public function setResponse(\Ups_pickup\upspickupStruct\Ups_pickupResponseType $response = null)
    {
        $this->Response = $response;
        return $this;
    }
    /**
     * Get PRN value
     * @return string|null
     */
    public function getPRN()
    {
        return $this->PRN;
    }
    /**
     * Set PRN value
     * @param string $pRN
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupCreationResponse
     */
    public function setPRN($pRN = null)
    {
        // validation for constraint: string
        if (!is_null($pRN) && !is_string($pRN)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pRN, true), gettype($pRN)), __LINE__);
        }
        $this->PRN = $pRN;
        return $this;
    }
    /**
     * Get WeekendServiceTerritoryIndicator value
     * @return string|null
     */
    public function getWeekendServiceTerritoryIndicator()
    {
        return $this->WeekendServiceTerritoryIndicator;
    }
    /**
     * Set WeekendServiceTerritoryIndicator value
     * @param string $weekendServiceTerritoryIndicator
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupCreationResponse
     */
    public function setWeekendServiceTerritoryIndicator($weekendServiceTerritoryIndicator = 'N')
    {
        // validation for constraint: string
        if (!is_null($weekendServiceTerritoryIndicator) && !is_string($weekendServiceTerritoryIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($weekendServiceTerritoryIndicator, true), gettype($weekendServiceTerritoryIndicator)), __LINE__);
        }
        $this->WeekendServiceTerritoryIndicator = $weekendServiceTerritoryIndicator;
        return $this;
    }
    /**
     * Get RateStatus value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupStatusCodeDescriptionType|null
     */
    public function getRateStatus()
    {
        return $this->RateStatus;
    }
    /**
     * Set RateStatus value
     * @param \Ups_pickup\upspickupStruct\Ups_pickupStatusCodeDescriptionType $rateStatus
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupCreationResponse
     */
    public function setRateStatus(\Ups_pickup\upspickupStruct\Ups_pickupStatusCodeDescriptionType $rateStatus = null)
    {
        $this->RateStatus = $rateStatus;
        return $this;
    }
    /**
     * Get RateResult value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupRateResultType|null
     */
    public function getRateResult()
    {
        return $this->RateResult;
    }
    /**
     * Set RateResult value
     * @param \Ups_pickup\upspickupStruct\Ups_pickupRateResultType $rateResult
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupCreationResponse
     */
    public function setRateResult(\Ups_pickup\upspickupStruct\Ups_pickupRateResultType $rateResult = null)
    {
        $this->RateResult = $rateResult;
        return $this;
    }
}
