<?php

namespace Ups_pickup\upspickupStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PickupFacilitiesType upspickupStruct
 * @package Ups_pickup
 * @subpackage Structs
 */
class Ups_pickupPickupFacilitiesType extends AbstractStructBase
{
    /**
     * The Name
     * @var string
     */
    public $Name;
    /**
     * The Address
     * @var \Ups_pickup\upspickupStruct\Ups_pickupAddressType
     */
    public $Address;
    /**
     * The SLIC
     * @var string
     */
    public $SLIC;
    /**
     * The Type
     * @var string
     */
    public $Type;
    /**
     * The Timezone
     * @var string
     */
    public $Timezone;
    /**
     * The Phone
     * @var string
     */
    public $Phone;
    /**
     * The Fax
     * @var string
     */
    public $Fax;
    /**
     * The FacilityTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_pickup\upspickupStruct\Ups_pickupFacilityTimeType
     */
    public $FacilityTime;
    /**
     * The OriginOrDestination
     * @var string
     */
    public $OriginOrDestination;
    /**
     * The AirportCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $AirportCode;
    /**
     * The SortCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $SortCode;
    /**
     * Constructor method for PickupFacilitiesType
     * @uses Ups_pickupPickupFacilitiesType::setName()
     * @uses Ups_pickupPickupFacilitiesType::setAddress()
     * @uses Ups_pickupPickupFacilitiesType::setSLIC()
     * @uses Ups_pickupPickupFacilitiesType::setType()
     * @uses Ups_pickupPickupFacilitiesType::setTimezone()
     * @uses Ups_pickupPickupFacilitiesType::setPhone()
     * @uses Ups_pickupPickupFacilitiesType::setFax()
     * @uses Ups_pickupPickupFacilitiesType::setFacilityTime()
     * @uses Ups_pickupPickupFacilitiesType::setOriginOrDestination()
     * @uses Ups_pickupPickupFacilitiesType::setAirportCode()
     * @uses Ups_pickupPickupFacilitiesType::setSortCode()
     * @param string $name
     * @param \Ups_pickup\upspickupStruct\Ups_pickupAddressType $address
     * @param string $sLIC
     * @param string $type
     * @param string $timezone
     * @param string $phone
     * @param string $fax
     * @param \Ups_pickup\upspickupStruct\Ups_pickupFacilityTimeType $facilityTime
     * @param string $originOrDestination
     * @param string $airportCode
     * @param string $sortCode
     */
    public function __construct($name = null, \Ups_pickup\upspickupStruct\Ups_pickupAddressType $address = null, $sLIC = null, $type = null, $timezone = null, $phone = null, $fax = null, \Ups_pickup\upspickupStruct\Ups_pickupFacilityTimeType $facilityTime = null, $originOrDestination = null, $airportCode = null, $sortCode = null)
    {
        $this
            ->setName($name)
            ->setAddress($address)
            ->setSLIC($sLIC)
            ->setType($type)
            ->setTimezone($timezone)
            ->setPhone($phone)
            ->setFax($fax)
            ->setFacilityTime($facilityTime)
            ->setOriginOrDestination($originOrDestination)
            ->setAirportCode($airportCode)
            ->setSortCode($sortCode);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Address value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupAddressType|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param \Ups_pickup\upspickupStruct\Ups_pickupAddressType $address
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType
     */
    public function setAddress(\Ups_pickup\upspickupStruct\Ups_pickupAddressType $address = null)
    {
        $this->Address = $address;
        return $this;
    }
    /**
     * Get SLIC value
     * @return string|null
     */
    public function getSLIC()
    {
        return $this->SLIC;
    }
    /**
     * Set SLIC value
     * @param string $sLIC
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType
     */
    public function setSLIC($sLIC = null)
    {
        // validation for constraint: string
        if (!is_null($sLIC) && !is_string($sLIC)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sLIC, true), gettype($sLIC)), __LINE__);
        }
        $this->SLIC = $sLIC;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Timezone value
     * @return string|null
     */
    public function getTimezone()
    {
        return $this->Timezone;
    }
    /**
     * Set Timezone value
     * @param string $timezone
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType
     */
    public function setTimezone($timezone = null)
    {
        // validation for constraint: string
        if (!is_null($timezone) && !is_string($timezone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($timezone, true), gettype($timezone)), __LINE__);
        }
        $this->Timezone = $timezone;
        return $this;
    }
    /**
     * Get Phone value
     * @return string|null
     */
    public function getPhone()
    {
        return $this->Phone;
    }
    /**
     * Set Phone value
     * @param string $phone
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType
     */
    public function setPhone($phone = null)
    {
        // validation for constraint: string
        if (!is_null($phone) && !is_string($phone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($phone, true), gettype($phone)), __LINE__);
        }
        $this->Phone = $phone;
        return $this;
    }
    /**
     * Get Fax value
     * @return string|null
     */
    public function getFax()
    {
        return $this->Fax;
    }
    /**
     * Set Fax value
     * @param string $fax
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType
     */
    public function setFax($fax = null)
    {
        // validation for constraint: string
        if (!is_null($fax) && !is_string($fax)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fax, true), gettype($fax)), __LINE__);
        }
        $this->Fax = $fax;
        return $this;
    }
    /**
     * Get FacilityTime value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupFacilityTimeType|null
     */
    public function getFacilityTime()
    {
        return $this->FacilityTime;
    }
    /**
     * Set FacilityTime value
     * @param \Ups_pickup\upspickupStruct\Ups_pickupFacilityTimeType $facilityTime
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType
     */
    public function setFacilityTime(\Ups_pickup\upspickupStruct\Ups_pickupFacilityTimeType $facilityTime = null)
    {
        $this->FacilityTime = $facilityTime;
        return $this;
    }
    /**
     * Get OriginOrDestination value
     * @return string|null
     */
    public function getOriginOrDestination()
    {
        return $this->OriginOrDestination;
    }
    /**
     * Set OriginOrDestination value
     * @param string $originOrDestination
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType
     */
    public function setOriginOrDestination($originOrDestination = null)
    {
        // validation for constraint: string
        if (!is_null($originOrDestination) && !is_string($originOrDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originOrDestination, true), gettype($originOrDestination)), __LINE__);
        }
        $this->OriginOrDestination = $originOrDestination;
        return $this;
    }
    /**
     * Get AirportCode value
     * @return string|null
     */
    public function getAirportCode()
    {
        return $this->AirportCode;
    }
    /**
     * Set AirportCode value
     * @param string $airportCode
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType
     */
    public function setAirportCode($airportCode = null)
    {
        // validation for constraint: string
        if (!is_null($airportCode) && !is_string($airportCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($airportCode, true), gettype($airportCode)), __LINE__);
        }
        $this->AirportCode = $airportCode;
        return $this;
    }
    /**
     * Get SortCode value
     * @return string|null
     */
    public function getSortCode()
    {
        return $this->SortCode;
    }
    /**
     * Set SortCode value
     * @param string $sortCode
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType
     */
    public function setSortCode($sortCode = null)
    {
        // validation for constraint: string
        if (!is_null($sortCode) && !is_string($sortCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sortCode, true), gettype($sortCode)), __LINE__);
        }
        $this->SortCode = $sortCode;
        return $this;
    }
}
