<?php

namespace Ups_pickup\upspickupStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PickupGetPoliticalDivision1ListResponse upspickupStruct
 * @package Ups_pickup
 * @subpackage Structs
 */
class Ups_pickupPickupGetPoliticalDivision1ListResponse extends AbstractStructBase
{
    /**
     * The Response
     * Meta information extracted from the WSDL
     * - ref: common:Response
     * @var \Ups_pickup\upspickupStruct\Ups_pickupResponseType
     */
    public $Response;
    /**
     * The PoliticalDivision1
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var string[]
     */
    public $PoliticalDivision1;
    /**
     * Constructor method for PickupGetPoliticalDivision1ListResponse
     * @uses Ups_pickupPickupGetPoliticalDivision1ListResponse::setResponse()
     * @uses Ups_pickupPickupGetPoliticalDivision1ListResponse::setPoliticalDivision1()
     * @param \Ups_pickup\upspickupStruct\Ups_pickupResponseType $response
     * @param string[] $politicalDivision1
     */
    public function __construct(\Ups_pickup\upspickupStruct\Ups_pickupResponseType $response = null, array $politicalDivision1 = array())
    {
        $this
            ->setResponse($response)
            ->setPoliticalDivision1($politicalDivision1);
    }
    /**
     * Get Response value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupResponseType|null
     */
    public function getResponse()
    {
        return $this->Response;
    }
    /**
     * Set Response value
     * @param \Ups_pickup\upspickupStruct\Ups_pickupResponseType $response
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupGetPoliticalDivision1ListResponse
     */
    public function setResponse(\Ups_pickup\upspickupStruct\Ups_pickupResponseType $response = null)
    {
        $this->Response = $response;
        return $this;
    }
    /**
     * Get PoliticalDivision1 value
     * @return string[]|null
     */
    public function getPoliticalDivision1()
    {
        return $this->PoliticalDivision1;
    }
    /**
     * This method is responsible for validating the values passed to the setPoliticalDivision1 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPoliticalDivision1 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePoliticalDivision1ForArrayConstraintsFromSetPoliticalDivision1(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pickupGetPoliticalDivision1ListResponsePoliticalDivision1Item) {
            // validation for constraint: itemType
            if (!is_string($pickupGetPoliticalDivision1ListResponsePoliticalDivision1Item)) {
                $invalidValues[] = is_object($pickupGetPoliticalDivision1ListResponsePoliticalDivision1Item) ? get_class($pickupGetPoliticalDivision1ListResponsePoliticalDivision1Item) : sprintf('%s(%s)', gettype($pickupGetPoliticalDivision1ListResponsePoliticalDivision1Item), var_export($pickupGetPoliticalDivision1ListResponsePoliticalDivision1Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PoliticalDivision1 property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PoliticalDivision1 value
     * @throws \InvalidArgumentException
     * @param string[] $politicalDivision1
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupGetPoliticalDivision1ListResponse
     */
    public function setPoliticalDivision1(array $politicalDivision1 = array())
    {
        // validation for constraint: array
        if ('' !== ($politicalDivision1ArrayErrorMessage = self::validatePoliticalDivision1ForArrayConstraintsFromSetPoliticalDivision1($politicalDivision1))) {
            throw new \InvalidArgumentException($politicalDivision1ArrayErrorMessage, __LINE__);
        }
        $this->PoliticalDivision1 = $politicalDivision1;
        return $this;
    }
    /**
     * Add item to PoliticalDivision1 value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupGetPoliticalDivision1ListResponse
     */
    public function addToPoliticalDivision1($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The PoliticalDivision1 property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PoliticalDivision1[] = $item;
        return $this;
    }
}
