<?php

namespace Ups_pickup\upspickupStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PickupPendingStatusResponse upspickupStruct
 * @package Ups_pickup
 * @subpackage Structs
 */
class Ups_pickupPickupPendingStatusResponse extends AbstractStructBase
{
    /**
     * The Response
     * Meta information extracted from the WSDL
     * - ref: common:Response
     * @var \Ups_pickup\upspickupStruct\Ups_pickupResponseType
     */
    public $Response;
    /**
     * The PendingStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType[]
     */
    public $PendingStatus;
    /**
     * Constructor method for PickupPendingStatusResponse
     * @uses Ups_pickupPickupPendingStatusResponse::setResponse()
     * @uses Ups_pickupPickupPendingStatusResponse::setPendingStatus()
     * @param \Ups_pickup\upspickupStruct\Ups_pickupResponseType $response
     * @param \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType[] $pendingStatus
     */
    public function __construct(\Ups_pickup\upspickupStruct\Ups_pickupResponseType $response = null, array $pendingStatus = array())
    {
        $this
            ->setResponse($response)
            ->setPendingStatus($pendingStatus);
    }
    /**
     * Get Response value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupResponseType|null
     */
    public function getResponse()
    {
        return $this->Response;
    }
    /**
     * Set Response value
     * @param \Ups_pickup\upspickupStruct\Ups_pickupResponseType $response
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupPendingStatusResponse
     */
    public function setResponse(\Ups_pickup\upspickupStruct\Ups_pickupResponseType $response = null)
    {
        $this->Response = $response;
        return $this;
    }
    /**
     * Get PendingStatus value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType[]|null
     */
    public function getPendingStatus()
    {
        return $this->PendingStatus;
    }
    /**
     * This method is responsible for validating the values passed to the setPendingStatus method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPendingStatus method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePendingStatusForArrayConstraintsFromSetPendingStatus(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pickupPendingStatusResponsePendingStatusItem) {
            // validation for constraint: itemType
            if (!$pickupPendingStatusResponsePendingStatusItem instanceof \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType) {
                $invalidValues[] = is_object($pickupPendingStatusResponsePendingStatusItem) ? get_class($pickupPendingStatusResponsePendingStatusItem) : sprintf('%s(%s)', gettype($pickupPendingStatusResponsePendingStatusItem), var_export($pickupPendingStatusResponsePendingStatusItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PendingStatus property can only contain items of type \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PendingStatus value
     * @throws \InvalidArgumentException
     * @param \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType[] $pendingStatus
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupPendingStatusResponse
     */
    public function setPendingStatus(array $pendingStatus = array())
    {
        // validation for constraint: array
        if ('' !== ($pendingStatusArrayErrorMessage = self::validatePendingStatusForArrayConstraintsFromSetPendingStatus($pendingStatus))) {
            throw new \InvalidArgumentException($pendingStatusArrayErrorMessage, __LINE__);
        }
        $this->PendingStatus = $pendingStatus;
        return $this;
    }
    /**
     * Add item to PendingStatus value
     * @throws \InvalidArgumentException
     * @param \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType $item
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupPendingStatusResponse
     */
    public function addToPendingStatus(\Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType) {
            throw new \InvalidArgumentException(sprintf('The PendingStatus property can only contain items of type \Ups_pickup\upspickupStruct\Ups_pickupPendingStatusType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PendingStatus[] = $item;
        return $this;
    }
}
