<?php

namespace Ups_pickup\upspickupStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PickupRateResponse upspickupStruct
 * @package Ups_pickup
 * @subpackage Structs
 */
class Ups_pickupPickupRateResponse extends AbstractStructBase
{
    /**
     * The Response
     * Meta information extracted from the WSDL
     * - ref: common:Response
     * @var \Ups_pickup\upspickupStruct\Ups_pickupResponseType
     */
    public $Response;
    /**
     * The RateResult
     * @var \Ups_pickup\upspickupStruct\Ups_pickupRateResultType
     */
    public $RateResult;
    /**
     * The WeekendServiceTerritoryIndicator
     * Meta information extracted from the WSDL
     * - default: N
     * - minOccurs: 0
     * @var string
     */
    public $WeekendServiceTerritoryIndicator;
    /**
     * Constructor method for PickupRateResponse
     * @uses Ups_pickupPickupRateResponse::setResponse()
     * @uses Ups_pickupPickupRateResponse::setRateResult()
     * @uses Ups_pickupPickupRateResponse::setWeekendServiceTerritoryIndicator()
     * @param \Ups_pickup\upspickupStruct\Ups_pickupResponseType $response
     * @param \Ups_pickup\upspickupStruct\Ups_pickupRateResultType $rateResult
     * @param string $weekendServiceTerritoryIndicator
     */
    public function __construct(\Ups_pickup\upspickupStruct\Ups_pickupResponseType $response = null, \Ups_pickup\upspickupStruct\Ups_pickupRateResultType $rateResult = null, $weekendServiceTerritoryIndicator = 'N')
    {
        $this
            ->setResponse($response)
            ->setRateResult($rateResult)
            ->setWeekendServiceTerritoryIndicator($weekendServiceTerritoryIndicator);
    }
    /**
     * Get Response value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupResponseType|null
     */
    public function getResponse()
    {
        return $this->Response;
    }
    /**
     * Set Response value
     * @param \Ups_pickup\upspickupStruct\Ups_pickupResponseType $response
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupRateResponse
     */
    public function setResponse(\Ups_pickup\upspickupStruct\Ups_pickupResponseType $response = null)
    {
        $this->Response = $response;
        return $this;
    }
    /**
     * Get RateResult value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupRateResultType|null
     */
    public function getRateResult()
    {
        return $this->RateResult;
    }
    /**
     * Set RateResult value
     * @param \Ups_pickup\upspickupStruct\Ups_pickupRateResultType $rateResult
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupRateResponse
     */
    public function setRateResult(\Ups_pickup\upspickupStruct\Ups_pickupRateResultType $rateResult = null)
    {
        $this->RateResult = $rateResult;
        return $this;
    }
    /**
     * Get WeekendServiceTerritoryIndicator value
     * @return string|null
     */
    public function getWeekendServiceTerritoryIndicator()
    {
        return $this->WeekendServiceTerritoryIndicator;
    }
    /**
     * Set WeekendServiceTerritoryIndicator value
     * @param string $weekendServiceTerritoryIndicator
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupRateResponse
     */
    public function setWeekendServiceTerritoryIndicator($weekendServiceTerritoryIndicator = 'N')
    {
        // validation for constraint: string
        if (!is_null($weekendServiceTerritoryIndicator) && !is_string($weekendServiceTerritoryIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($weekendServiceTerritoryIndicator, true), gettype($weekendServiceTerritoryIndicator)), __LINE__);
        }
        $this->WeekendServiceTerritoryIndicator = $weekendServiceTerritoryIndicator;
        return $this;
    }
}
