<?php

namespace Ups_pickup\upspickupStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceCenterLocationsType upspickupStruct
 * @package Ups_pickup
 * @subpackage Structs
 */
class Ups_pickupServiceCenterLocationsType extends AbstractStructBase
{
    /**
     * The DropOffFacilities
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Ups_pickup\upspickupStruct\Ups_pickupDropOffFacilitiesType[]
     */
    public $DropOffFacilities;
    /**
     * The PickupFacilities
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType
     */
    public $PickupFacilities;
    /**
     * Constructor method for ServiceCenterLocationsType
     * @uses Ups_pickupServiceCenterLocationsType::setDropOffFacilities()
     * @uses Ups_pickupServiceCenterLocationsType::setPickupFacilities()
     * @param \Ups_pickup\upspickupStruct\Ups_pickupDropOffFacilitiesType[] $dropOffFacilities
     * @param \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType $pickupFacilities
     */
    public function __construct(array $dropOffFacilities = array(), \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType $pickupFacilities = null)
    {
        $this
            ->setDropOffFacilities($dropOffFacilities)
            ->setPickupFacilities($pickupFacilities);
    }
    /**
     * Get DropOffFacilities value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupDropOffFacilitiesType[]|null
     */
    public function getDropOffFacilities()
    {
        return $this->DropOffFacilities;
    }
    /**
     * This method is responsible for validating the values passed to the setDropOffFacilities method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDropOffFacilities method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDropOffFacilitiesForArrayConstraintsFromSetDropOffFacilities(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $serviceCenterLocationsTypeDropOffFacilitiesItem) {
            // validation for constraint: itemType
            if (!$serviceCenterLocationsTypeDropOffFacilitiesItem instanceof \Ups_pickup\upspickupStruct\Ups_pickupDropOffFacilitiesType) {
                $invalidValues[] = is_object($serviceCenterLocationsTypeDropOffFacilitiesItem) ? get_class($serviceCenterLocationsTypeDropOffFacilitiesItem) : sprintf('%s(%s)', gettype($serviceCenterLocationsTypeDropOffFacilitiesItem), var_export($serviceCenterLocationsTypeDropOffFacilitiesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DropOffFacilities property can only contain items of type \Ups_pickup\upspickupStruct\Ups_pickupDropOffFacilitiesType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DropOffFacilities value
     * @throws \InvalidArgumentException
     * @param \Ups_pickup\upspickupStruct\Ups_pickupDropOffFacilitiesType[] $dropOffFacilities
     * @return \Ups_pickup\upspickupStruct\Ups_pickupServiceCenterLocationsType
     */
    public function setDropOffFacilities(array $dropOffFacilities = array())
    {
        // validation for constraint: array
        if ('' !== ($dropOffFacilitiesArrayErrorMessage = self::validateDropOffFacilitiesForArrayConstraintsFromSetDropOffFacilities($dropOffFacilities))) {
            throw new \InvalidArgumentException($dropOffFacilitiesArrayErrorMessage, __LINE__);
        }
        $this->DropOffFacilities = $dropOffFacilities;
        return $this;
    }
    /**
     * Add item to DropOffFacilities value
     * @throws \InvalidArgumentException
     * @param \Ups_pickup\upspickupStruct\Ups_pickupDropOffFacilitiesType $item
     * @return \Ups_pickup\upspickupStruct\Ups_pickupServiceCenterLocationsType
     */
    public function addToDropOffFacilities(\Ups_pickup\upspickupStruct\Ups_pickupDropOffFacilitiesType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups_pickup\upspickupStruct\Ups_pickupDropOffFacilitiesType) {
            throw new \InvalidArgumentException(sprintf('The DropOffFacilities property can only contain items of type \Ups_pickup\upspickupStruct\Ups_pickupDropOffFacilitiesType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DropOffFacilities[] = $item;
        return $this;
    }
    /**
     * Get PickupFacilities value
     * @return \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType|null
     */
    public function getPickupFacilities()
    {
        return $this->PickupFacilities;
    }
    /**
     * Set PickupFacilities value
     * @param \Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType $pickupFacilities
     * @return \Ups_pickup\upspickupStruct\Ups_pickupServiceCenterLocationsType
     */
    public function setPickupFacilities(\Ups_pickup\upspickupStruct\Ups_pickupPickupFacilitiesType $pickupFacilities = null)
    {
        $this->PickupFacilities = $pickupFacilities;
        return $this;
    }
}
