<?php

namespace Ups_pickup\upspickupStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TodayType upspickupStruct
 * @package Ups_pickup
 * @subpackage Structs
 */
class Ups_pickupTodayType extends AbstractStructBase
{
    /**
     * The LocalDate
     * @var string
     */
    public $LocalDate;
    /**
     * The LocalTime
     * @var string
     */
    public $LocalTime;
    /**
     * The CallByTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $CallByTime;
    /**
     * The EarliestCloseTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $EarliestCloseTime;
    /**
     * The LeadTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $LeadTime;
    /**
     * The GWNIndicator
     * Meta information extracted from the WSDL
     * - default: N
     * - minOccurs: 0
     * @var string
     */
    public $GWNIndicator;
    /**
     * Constructor method for TodayType
     * @uses Ups_pickupTodayType::setLocalDate()
     * @uses Ups_pickupTodayType::setLocalTime()
     * @uses Ups_pickupTodayType::setCallByTime()
     * @uses Ups_pickupTodayType::setEarliestCloseTime()
     * @uses Ups_pickupTodayType::setLeadTime()
     * @uses Ups_pickupTodayType::setGWNIndicator()
     * @param string $localDate
     * @param string $localTime
     * @param string $callByTime
     * @param string $earliestCloseTime
     * @param string $leadTime
     * @param string $gWNIndicator
     */
    public function __construct($localDate = null, $localTime = null, $callByTime = null, $earliestCloseTime = null, $leadTime = null, $gWNIndicator = 'N')
    {
        $this
            ->setLocalDate($localDate)
            ->setLocalTime($localTime)
            ->setCallByTime($callByTime)
            ->setEarliestCloseTime($earliestCloseTime)
            ->setLeadTime($leadTime)
            ->setGWNIndicator($gWNIndicator);
    }
    /**
     * Get LocalDate value
     * @return string|null
     */
    public function getLocalDate()
    {
        return $this->LocalDate;
    }
    /**
     * Set LocalDate value
     * @param string $localDate
     * @return \Ups_pickup\upspickupStruct\Ups_pickupTodayType
     */
    public function setLocalDate($localDate = null)
    {
        // validation for constraint: string
        if (!is_null($localDate) && !is_string($localDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($localDate, true), gettype($localDate)), __LINE__);
        }
        $this->LocalDate = $localDate;
        return $this;
    }
    /**
     * Get LocalTime value
     * @return string|null
     */
    public function getLocalTime()
    {
        return $this->LocalTime;
    }
    /**
     * Set LocalTime value
     * @param string $localTime
     * @return \Ups_pickup\upspickupStruct\Ups_pickupTodayType
     */
    public function setLocalTime($localTime = null)
    {
        // validation for constraint: string
        if (!is_null($localTime) && !is_string($localTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($localTime, true), gettype($localTime)), __LINE__);
        }
        $this->LocalTime = $localTime;
        return $this;
    }
    /**
     * Get CallByTime value
     * @return string|null
     */
    public function getCallByTime()
    {
        return $this->CallByTime;
    }
    /**
     * Set CallByTime value
     * @param string $callByTime
     * @return \Ups_pickup\upspickupStruct\Ups_pickupTodayType
     */
    public function setCallByTime($callByTime = null)
    {
        // validation for constraint: string
        if (!is_null($callByTime) && !is_string($callByTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callByTime, true), gettype($callByTime)), __LINE__);
        }
        $this->CallByTime = $callByTime;
        return $this;
    }
    /**
     * Get EarliestCloseTime value
     * @return string|null
     */
    public function getEarliestCloseTime()
    {
        return $this->EarliestCloseTime;
    }
    /**
     * Set EarliestCloseTime value
     * @param string $earliestCloseTime
     * @return \Ups_pickup\upspickupStruct\Ups_pickupTodayType
     */
    public function setEarliestCloseTime($earliestCloseTime = null)
    {
        // validation for constraint: string
        if (!is_null($earliestCloseTime) && !is_string($earliestCloseTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($earliestCloseTime, true), gettype($earliestCloseTime)), __LINE__);
        }
        $this->EarliestCloseTime = $earliestCloseTime;
        return $this;
    }
    /**
     * Get LeadTime value
     * @return string|null
     */
    public function getLeadTime()
    {
        return $this->LeadTime;
    }
    /**
     * Set LeadTime value
     * @param string $leadTime
     * @return \Ups_pickup\upspickupStruct\Ups_pickupTodayType
     */
    public function setLeadTime($leadTime = null)
    {
        // validation for constraint: string
        if (!is_null($leadTime) && !is_string($leadTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($leadTime, true), gettype($leadTime)), __LINE__);
        }
        $this->LeadTime = $leadTime;
        return $this;
    }
    /**
     * Get GWNIndicator value
     * @return string|null
     */
    public function getGWNIndicator()
    {
        return $this->GWNIndicator;
    }
    /**
     * Set GWNIndicator value
     * @param string $gWNIndicator
     * @return \Ups_pickup\upspickupStruct\Ups_pickupTodayType
     */
    public function setGWNIndicator($gWNIndicator = 'N')
    {
        // validation for constraint: string
        if (!is_null($gWNIndicator) && !is_string($gWNIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($gWNIndicator, true), gettype($gWNIndicator)), __LINE__);
        }
        $this->GWNIndicator = $gWNIndicator;
        return $this;
    }
}
